<?php
// archivo: mantdepto.php
// Este archivo: /admin/mandepto.php
// explicacin captulo 15
require_once("plantilla.php");

// Esta pgina permite aadir, modificar o eliminar
// departamentos de la tienda
// Es una pgina que slo utilizar el administrador
// del sitio de comercio electrnico; ningn cliente
// del sitio tendr acceso a ella.


//$_POST["IDepartamentoID"]=2;
//$_POST["INombre"]="ee";
//$_POST["IImagen"]="ww";
//$_POST["IDepartamentoRaizID"]=0;
//$_POST["Op"]="BuscarTabla";
//$_POST["Texto"]="Dibu";

//$_SERVER["PHP_AUTH_USER"]="admincom";
//$_SERVER["PHP_AUTH_PW"]="123456";
//$_SESSION['Autenticado']=1 ;
//$_POST['vDepartamentoID']=7;
//$_POST['vDepartamentoRaizID']=0;
//$_POST['vNombre']='Hsitorias\'A\"C';
//$_POST['vImagen']="err";
//$_POST['Op']="Modificar";

if ($_SESSION['Autenticado']!=1 ) {       
      redirect("admin.php");
}

// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin de aplicaciones
abrirPagina(true,$aMENUADM);

////////////////////////////////////////////////////
// enlaces a otras pginas
////////////////////////////////////////////////////
// Tabla de navegacin del administrador del sitio
// tareas disponibles dentro de la aplicacin actual
tabnavegaA($aMENU02,LIT09001,LIT00011);

// Rutina de bsqueda de los libros de un departamento
if  ($_POST["Op"]=="Buscar"){
   redirect("mantlibros.php?vDepartamentoID=".$_POST["vDepartamentoID"]."&VerDepto=Buscar");
}

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios de administrador
////////////////////////////////////////////////////
conectar(USERADMIN,PSWUSERADMIN);

$oDepto = new Departamento();
$sfiltro ="";
// Rutina de insercin de un nuevo Departamento de la librera
if (($_POST["Op"]=="Aadir")) {
      $oDepto->DepartamentoRaizID = $_POST["IDepartamentoRaizID"];
      $oDepto->Nombre = $_POST["INombre"];
      $oDepto->Imagen = $_POST["IImagen"]; 
      $oDepto->aadirDepartamento();  
} 
// Rutina de modificacin de un departamento de la librera
elseif ($_POST["Op"]=="Modificar"){ 
      $oDepto->DepartamentoID = $_POST["vDepartamentoID"];
      $oDepto->DepartamentoRaizID = $_POST["vDepartamentoRaizID"];
      $oDepto->Nombre = $_POST["vNombre"];
      $oDepto->Imagen = $_POST["vImagen"]; 
      $oDepto->modificarDepartamento();
}
// Rutina de eliminacin de un departamento de la librera
elseif ($_POST["Op"]=="Eliminar") {
      $oDepto->DepartamentoID = $_POST["vDepartamentoID"];
      $oDepto->eliminarDepartamento();
}
// Rutina de filtrado de departamentos
elseif ($_POST["Op"]=="BuscarTabla"){
      $sfiltro="WHERE Nombre Like '%".trim($_POST['BTexto'])."%'";
}

// Creacin del objeto conjunto de departamentos
$oDeptos = new Departamentos;
$aDeptos = $oDeptos->leerDepartamentos($sfiltro,"DepartamentoRaizID ASC, Nombre ASC");
$aTemp=$aDeptos;
$aTemp[]['DepartamentoID']="0"; 
$aTemp[]['Nombre']="Ninguno"; 

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$oTab2->asignar_titulos_columnas(LIT09002,LIT09003,LIT09004,LIT09005,"","",LIT09006);

//////////////////////////////////////////////////////////////////
// Formularios para la eliminacin y modificacin de departamentos
// uno por cada lnea de la tabla
// navega por el conjunto de resultados
//////////////////////////////////////////////////////////////////
$op="<option value='0' >Ninguno</option>";

$i=0;
while ($i < $oDeptos->cantDepartamentos()){

  unset($aO);
  $aO[0]="<form name='form09".$i ."' method='POST' action='".SELF."' enctype='multipart/form-data'>";
  $aO[0].="<input type='hidden' name='vDepartamentoID' value=\"".$aDeptos[$i]['DepartamentoID']."\">";
  $aO[1]="<input type='text' name='vDepartamentoRaizID' value=\"".$aDeptos[$i]['DepartamentoRaizID']."\" onChange='validar(this,\"N\");'>";
  $aO[1]= "<select name='vDepartamentoRaizID'>";
  reset($aTemp);
  foreach ($aTemp as $temp) {
         $sel="";
         if ($temp['DepartamentoID']==$aDeptos[$i]['DepartamentoRaizID']) $sel = "selected='selected'";
         $aO[1].= "<option value='".$temp['DepartamentoID']."'" .$sel.">".$temp['Nombre']."</option>";
  }
  $aO[1].= "</select>";
  $aO[2]="<input type='text' name='vNombre' value=\"".clean($aDeptos[$i]['Nombre'])."\">";
  $aO[3]="<input type='text' name='vImagen' value=\"".clean($aDeptos[$i]['Imagen'])."\">";
  $aO[4]="<input type='image' src ='".PATHGIF."eliminar.gif'   
   value='Eliminar' TITLE='".LIT00007."'   onClick='document.form09".$i.".Op.value=\"Eliminar\";' >\n";
  $aO[5]="<input type='image' src ='".PATHGIF."modificar.gif'   
   value='Modificar' TITLE='".LIT00008."' onClick='document.form09".$i.".Op.value=\"Modificar\";' >\n";
  $aO[6]="<input type='image' src ='".PATHGIF."buscar.gif'   
   value='Buscar' TITLE='".LIT00010."' onClick='document.form09".$i.".Op.value=\"Buscar\";' >\n";
  $aO[6].="<input type='hidden' name='Op' value=' '>\n";
  $aO[7]="</form>";
  $op.= "<option value='".$aDeptos[$i]['DepartamentoID']."' >".$aDeptos[$i]['Nombre']."</option>";

  // se utiliza el identificador del departamento como ttulo de la fila
  // esta columna no se puede modificar
  $sTitFila[]=$aDeptos[$i]['DepartamentoID'];

  $oTab2->aadir_fila($aO);
  $i++;
}


////////////////////////////////////////////////////////
// Formulario para la insercin de nuevos departamentos
//////////////////////////////////////////////////////// 
unset($aO);
$aO[0]="<form name='form09' method='POST' action='".SELF."' enctype='multipart/form-data'>";
$sTitFila[]=" ";
$aO[1]="<select name='IDepartamentoRaizID'>".$op."</select>";
$aO[2]="<input type='text' name='INombre' value=' ' size='20'>";
$aO[3]="<input type='text' name='IImagen' value=' ' size='20'>";
$aO[4]="<input type='image' src ='".PATHGIF."insertar.gif'   
  value='Aadir' TITLE='".LIT00010."' onClick='document.form09.Op.value=\"Aadir\";' >\n";
$aO[4].="<input type='hidden' name='Op' value=' '>\n";
$aO[5]="</form>";

$oTab2->aadir_fila($aO);

// coloca los ttulos de cada fila
$oTab2->asignar_titulos_filas($sTitFila);

echo $oTab2->retornoHTML();
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>
  