<?php
// archivo: mantprov.php
// Este archivo: /admin/mantprov.php
// explicacin en captulo 16

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");

// Esta pgina permite realizar el mantenimiento de proveedores
// por lo que slo la utiliza el administrador (autenticado)
// Desde esta pgina se pueden realizar altas, bajas y modificaciones
// de la tabla de proveedores

if ($_SESSION['Autenticado']!=1 ) {       
      redirect("admin.php");
} 
//$_SESSION =Array ( "Autenticado" => "1" , "LOGIN" => "admincom", "PalabraPaso" => "123456" );
//$_POST =Array ( "vProveedorID" => "2", "vNombre" => "D\'Andrea", "vApellidos" => "Rey Paz",  "vEmpresa" => "Distribuidora Norte", "vEMail" => "q@w.com", "Op" => "Modificar" ); 


// Rutina de bsqueda de los libros de un nuevo proveedor
// Enlaza con el catlogo de libros y all se listarn los libros
// relacionados con este proveedor
if  ($_POST["Op"]=="Buscar") {
   redirect("mantlibros.php?vProveedorID=".$_POST["vProveedorID"]."&VerProv=Buscar");
}

// informacin del encabezado
asignarEncabezado();

// logotipo y men de navegacin
abrirPagina(true,$aMENUADM);

// tabla de navegacin del administrador del sitio
tabnavegaA($aMENU02,LIT11001,LIT00011);

////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios de administrador
////////////////////////////////////////////////////
conectar(USERADMIN,PSWUSERADMIN);

$oProv = New Proveedor();
$sFiltro="";
// Rutina de insercin de un nuevo proveedor de la librera
if (($_POST["Op"]=="Aadir")) {
      $oProv->Nombre = $_POST["INombre"];
      $oProv->Apellidos = $_POST["IApellidos"];
      $oProv->Empresa = $_POST["IEmpresa"];
      $oProv->EMail = $_POST["IEMail"];
      $oProv->aadirProveedor(); 
   
}
// Rutina de modificacin de un departamento de la librera
elseif ($_POST["Op"]=="Modificar") {
      $oProv->ProveedorID = $_POST["vProveedorID"];
      $oProv->Nombre = $_POST["vNombre"];
      $oProv->Apellidos = $_POST["vApellidos"];
      $oProv->Empresa = $_POST["vEmpresa"];
      $oProv->EMail = $_POST["vEMail"];
      $oProv->modificarProveedor(); 
 
}
// Rutina de eliminacin de un departamento de la librera
elseif ($_POST["Op"]=="Eliminar") {
      $oProv->ProveedorID = $_POST["vProveedorID"];
      $oProv->eliminarProveedor(); 
}

// Rutina de filtrado de proveedores
elseif ($_POST["Op"]=="BuscarTabla") {
  $sFiltro=" WHERE Nombre Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="     Apellidos Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="     Empresa Like '%".trim($_POST['BTexto'])."%' or ";
  $sFiltro.="     EMail Like '%".trim($_POST['BTexto'])."%'";
}

$oProvs = New Proveedores;
$aProvs = $oProvs->leerProveedores($sFiltro); 

// Crea un objeto TablaHTML
$oTab2 = new  TablaHTML("Comercio");

// Coloca los ttulos de las columnas
$oTab2->asignar_titulos_columnas(LIT11002,LIT11003,LIT11004,
								LIT11005,LIT11006,LIT11007,
								LIT11008,LIT11009);



// Formularios para la eliminacin y modificacin de proveedores
// uno por cada lnea de la tabla
// navega por el conjunto de resultados
$op="<option value='0' >Ninguno</option>";

// iteracin por el conjunto de resultados de la lectura de la tabla
$i=0;

while ($i < $oProvs->cantProveedores()) {
  unset($aB);
  $aB[0]="<form name='form11".$i."' method='POST' enctype='multipart/form-data'>";
  $aB[0].="<input type='hidden' name='vProveedorID' value='".$aProvs[$i]['ProveedorID']."'>";
  $aB[1]="<input type='text' name='vNombre' value=\"".clean($aProvs[$i]['Nombre'])."\" onChange='validar(this,\"AN\",".LIT10010.");'>";
  $aB[2]="<input type='text' name='vApellidos' value=\"".clean($aProvs[$i]['Apellidos'])."\">";
  $aB[3]="<input type='text' name='vEmpresa' value=\"".clean($aProvs[$i]['Empresa'])."\" >";
  $aB[4]="<input type='text' name='vEMail' value=\"".clean($aProvs[$i]['EMail'])."\" onChange='validarEmail(this);'>";
  $aB[5]="<input type='image' src ='".PATHGIF."eliminar.gif'   
  value='Eliminar' TITLE='".LIT00007."'   onClick='document.form11".$i.".Op.value=\"Eliminar\";' >\n";
  $aB[6]="<input type='image' src ='".PATHGIF."modificar.gif'   
  value='Modificar' TITLE='".LIT00008."' onClick='document.form11".$i.".Op.value=\"Modificar\";' >\n";
  $aB[7]="<input type='image' src ='".PATHGIF."buscar.gif'   
  value='Buscar' TITLE='".LIT00010."' onClick='document.form11".$i.".Op.value=\"Buscar\";' >\n";
  $aB[7].="<input type='hidden' name='Op' value=' '>\n";
  $aB[8]="</form>";
  $i++;
  // se utiliza el identificador del proveedor como ttulo de la fila
  // esta columna no se puede modificar
  $sTitFila[]=$aProvs[$i]['ProveedorID'];

  $oTab2->aadir_fila($aB);
}

// Formulario para la insercin de nuevos proveedores
unset($aB);
$aB[0]="<form name='form11' method='POST' action='".SELF."' enctype='multipart/form-data'>";
$sTitFila[]=" ";
$aB[1]="<input type='text' name='INombre' value='' onChange='validar(this,\"AN\",".LIT10010.");'>";
$aB[2]="<input type='text' name='IApellidos' value='' >";
$aB[3]="<input type='text' name='IEmpresa' value='' >";
$aB[4]="<input type='text' name='IEmail' value='' onChange='validarEmail(this);'>";
$aB[5]="<input type='image' src ='".PATHGIF."insertar.gif'   
  value='Aadir' TITLE='".LIT00010."' onClick='document.form11.Op.value=\"Aadir\";' >\n";
$aB[5].="<input type='hidden' name='Op' value=' '>\n";
$aB[6]="</form>";

$oTab2->aadir_fila($aB);

// coloca los ttulos de cada fila
$oTab2->asignar_titulos_filas($sTitFila);

echo $oTab2->retornoHTML();
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>