<?php
class Cliente { // clase Cliente	
	// explicacin captulo 13
	
  	/*
   	* Propiedades de la clase Cliente 
   	*/   
	private $_aLista;
	private $_bDirty;
	    
   	/*
    * Mtodos
    * Cliente() // Constructor
    * leerCliente() 
    * aadirCliente()
    * modificarCliente()
    * validarCliente($sEmail,$PalabraPaso)
    */
function Cliente(){ // constructor
     
	global $con; 
	$this->_bDirty = False;
	$this->_aLista = array();
	
	// obtencin de datos del cliente
	if (isset($_SESSION['Cliente'])) { // ya existe el cliente
		$this->leerCliente();
	}  
        
} // fin constructor

function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
			return $this->_aLista[$nv];
	}
	else{
		return False;
	} 
}  // fin funcin _get
	 
function __set($nv,$val){
		 
	$this->_aLista[$nv] = $val;
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set

function leerCliente(){
      
	global $con; 
	// Rutina de lectura de un  cliente
	$sql = "SELECT * FROM Clientes
			WHERE ClienteID = " . $_SESSION['Cliente'] ;

	$rst=accederMySQL($sql);
	$this->_aLista = $rst->fetch_assoc();
	return $this->_aLista;
        
} // fin leerCliente
	
function aadirCliente() { // Aadir un nuevo cliente

	global $con;
         
	// Rutina de insercin de un cliente nuevo
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sqln="";
	$sqlv="";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "ClienteID"){    
			$sqln =  $sqln .  $key. " ,";
			$sqlv = $sqlv . "'".$value."',";
		}
	}
	$sql = "INSERT INTO Clientes ( ".substr($sqln,0,strlen($sqln)-1).
			") VALUES (".substr($sqlv,0,strlen($sqlv)-1).");";
 
	// obtiene el identificador de autoincremento		
	$_SESSION['Cliente'] =accederMySQL($sql,"ID");

	// actualiza la matriz de campos 
	$this->leerCliente();
         
   
} // fin aadir cliente
    
function modificarCliente() { // Modifica los datos de un cliente

	global $con;
	
	// Rutina de modificacin de campos de la tabla
	if ($this->_bDirty) {
        $this->UltimaMod = date("Y-m-d H:i:s");
        $sql= "UPDATE Clientes SET ";
        foreach ($this->_aLista as $key => $value){  
               if ($key <> "ClienteID"){    
                  $sql =  $sql . " " . $key . " = '". $value . "' ,";
               }
         }
         $sql = substr($sql,0,strlen($sql)-1)." WHERE ClienteID = ".$_SESSION["Cliente"] .";";
	}
	// limpia el indicador de modificacin pendiente
	$this->_bDirty = False;
       

    $rst=accederMySQL($sql);
    $this->leerCliente();
      
} // fin modificarCliente   
         
function validarCliente($sEmail,$PalabraPaso) { // Validar el cliente
	
	global $con;
	$sql= "SELECT * FROM  CLIENTES
			WHERE
                EMail = '".trim($sEmail)."' AND
                PalabraPaso = '".trim($PalabraPaso)."';";

	$rst=accederMySQL($sql);

	// Existe el cliente/contrasea?
	if  ($rst->num_rows== 0)  {
		$bReturn = False;
	}
	else {
		$this->_aLista = $rst->fetch_assoc(); 
		$bReturn = True;
	}
	$rst->free();
	return $bReturn;
}

} // fin clase Cliente
 
?>

