<?php
class Departamento { // clase Departamento
	// explicacin en captulo 15

	/**
    * Propiedad 
    */
	private $_aLista;
	private $_bDirty;
	/*
    * Mtodos
    * Departamento() // Constructor
    * aadirDepartamento()
    * modificarDepartamento()
    * eliminarDepartamento()
    * leerDepartamento()
    */

 
function Departamento($iDepartamentoID=0){
     
	$this->_aLista = array();
	$this->_bDirty = False;
	
	// Obtener un departamento ya existente
	if ($iDepartamentoID <>0)  { // ya existe el Departamento
		$this->DepartamentoID = $iDepartamentoID;
		$this->leerDepartamento();
	}  

	 
} // fin constructor

function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) {
		return $this->_aLista[$nv];
	}
	else{
		return False;
		} 
}  // fin funcin _get
	 
function __set($nv,$val){
		 
	$this->_aLista[$nv] = $val;
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set


function aadirDepartamento() {
	
	// Rutina de insercin de un nuevo departamento
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	
	// sentencia SQL de insercin
	$sql="INSERT INTO Departamentos
            (DepartamentoRaizID, 
             Nombre, 
             Imagen,
             UltimaMod,
             FechaCreacion) 
            VALUES 
            (\"".$this->DepartamentoRaizID."\",
             \"".$this->Nombre."\",
             \"".$this->Imagen."\",
             \"".$this->UltimaMod."\",
             \"".$this->FechaCreacion."\");";
      
	$this->DepartamentoID = accederMySQL($sql,"ID");
              
} // fin funcin aadirDepartamento()

function modificarDepartamento() {
	
	$this->UltimaMod = date("Y-m-d H:i:s");
	if (!$this->_bDirty)    return  ;
	 
	if ($this->DepartamentoID == $this->DepartamentoRaizID){
		tratarError(LIT16005);
		return;
	}
	
	// sentencia SQL de modificacin de campos
	$sql="UPDATE Departamentos SET 
            DepartamentoRaizID =\"". $this->DepartamentoRaizID."\",
            Nombre = \"".$this->Nombre."\", 
            Imagen = \"".$this->Imagen."\", 
            UltimaMod = \"".$this->UltimaMod."\" 
            WHERE 
            DepartamentoID = \"".$this->DepartamentoID."\";";
	
	$aRows = accederMySQL($sql,"ROWS");
	if ($aRows == 0) {
		tratarError(LIT16003,$sql);
	}
	$this->_bDirty = False;
	
} // fin funcin modificarDepartamento()

function eliminarDepartamento() {
      // se verifica que ese departamento no tenga otros departamentos 
      // dependientes  es una autoreferencia a la propia tabla
      
	$sql="SELECT Count(*) FROM Departamentos 
            WHERE 
            DepartamentoRaizID = \"".$this->DepartamentoID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);


	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el departamento: otros departamentos dependen de l.
		tratarError(LIT16001);
		$rst->free();
		return;
	}
      
	// Vinculaciones
	// por si no se activa el control de relaciones
	// esto es redundante, ya que MySQL
	// controlar la relacin
      
	$sql="SELECT Count(*) FROM Libros 
            WHERE DepartamentoID = \"".$this->DepartamentoID."\";";

	// crea el conjunto de resultados
	$rst = accederMySQL($sql);

	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el departamento: hay libros que dependen de l.
		tratarError(LIT16002);
		$rst->free();
		return;
	}
      
	$sql="DELETE FROM Departamentos 
			WHERE DepartamentoID = \"".$this->DepartamentoID."\";";
	$aRows = accederMySQL($sql,"ROWS");
	if ($aRows == 0) {
		tratarError(LIT16004,$sql);
	}
	
} // fin funcin eliminarDepartamento() 

private function leerDepartamento(){         
         
	// Rutina de lectura de un  Departamento
	$sql = "SELECT * FROM Departamento
			WHERE DepartamentoID = " . $this->DepartamentoID ;

	$rst = accederMySQL($sql);
 
	$this->_aLista = $rst->fetch_assoc();
   
} // fin funcin leerDepartamento()
 
}

?>
