<?php
class Cesta { // clase Cesta
// explicacin captulo 19

   /**
    * Propiedades
    */
    private $_aLista=array();
    private $_aItems=array();
    private $_bDirty=False;
   /*
    * Mtodos
    * Cesta() // Constructor
    * aadirCesta()
    * modificarCesta()
    * eliminarCesta()  
    * leerItemsCesta() 
    * totalizarCesta() 
    * cantItems()
    * leerCesta() 

    */
function Cesta() { // Constructor
  
        
	if (isset($_SESSION['Cesta'])) { // ya existe una cesta
		 $sql = "SELECT * FROM Cesta
                 WHERE CestaID = " . $_SESSION['Cesta'] ;

		$rst = accederMySQL($sql);
       
		$this->_aLista = $rst->fetch_assoc();
		$this->leerItemsCesta();
	} else { // no existe una cesta
            $this->aadirCesta();
	} 

} // fin constructor
    
function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) )  
		return $this->_aLista[$nv];
	else 
		return False;

}  // fin funcin _get
	 
function __set($nv,$val){
		 
	$this->_aLista[$nv] = $val;
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set
	
function aadirCesta(){ // Aadir una cesta
     
	// Rutina de insercin de una nueva cesta
	$dNow = date("Y-m-d H:i:s");
	$sql = "INSERT INTO Cesta (ClienteID, FechaCreacion )
                VALUES
                (" . $_SESSION ['Cliente'] . ", '" . $dNow . "');";

	$this->_aLista['CestaID'] = accederMySQL($sql,"ID");
	$_SESSION['Cesta'] = $this->_aLista['CestaID'];
	$this->_aLista['FechaCreacion'] = $dNow;
        
} // fin funcin aadirCesta
    
function modificarCesta() {// Actualizar cesta

	// Rutina de actualizacin de la cesta
	if (!$this->_bDirty) return;
         
	$sql= "UPDATE Cesta SET ";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "CestaID") {    
                  $sql =  $sql . " " . $key . " = '". $value . "' ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE CestaID = ".$this->CestaID .";";
	$rst=AccederMySQL($sql);
	$this->_bDirty = False;
        
} // fin funcin modificarCesta
    
function eliminarCesta() {
 
	//elimina la cesta
    if (isset($_SESSION['Cesta'])) {
    	// elimina los items de cesta
    	// se podra haber definido la relacin 
		// Cesta e ItemCesta de manera que se
		// produjese el borrado automtico en cascada
		// pero se prefiere este mtodo
		$sql= "DELETE FROM ItemCesta
            WHERE   CestaID = \"".$_SESSION['Cesta']."\";";

    	$rst=accederMySQL($sql);
         
	    // ahora elimina la cesta
		$sql= "DELETE FROM Cesta
            WHERE  CestaID = \"".$_SESSION['Cesta']."\";";

		$rst=accederMySQL($sql);
 
	}
} // fin funcin eliminarCesta

function leerItemsCesta() { // Lee contenido con descripcin

      $oItemsCesta = New ItemsCesta;
      $this->_aItems = array();
      $this->_aItems = $oItemsCesta->leerItemsCesta();
      return $this->_aItems;
      
}  // fin funcin leerItemsCesta

function totalizarCesta() { // suma campos
	$this->_aLista['AcumPrecio'] = 0;
	$this->_aLista['AcumIVA'] = 0;
	$this->_aLista['AcumPeso'] = 0;
	$this->_aLista['AcumPrecioVP'] = 0;
	$this->_aLista['TotalCargo'] = 0;
	$this->_aLista['GastosEnvio'] = 0;
	
	foreach($this->_aItems as $item){
      		$this->_aLista['AcumPrecio'] += $item['PrecioT'];
      		$this->_aLista['AcumIVA'] += $item['IVAT'];
      		$this->_aLista['AcumPeso'] += $item['PesoT'];
      		$this->_aLista['AcumPrecioVP'] += $item['PrecioVP'];
    }
    
    // Calcula los gastos de envo
	$this->_aLista['GastosEnvio']=tarifaEnvio($this->AcumPeso,$this->TipoEnvio);

	// Calcula el cargo total
	$this->_aLista['TotalCargo']=$this->AcumPrecioVP+$this->GastosEnvio;
      
}  // fin funcin totalizarCesta
    
 
function cantItemsCesta() {
	
	// informa la cantidad de ItemsCesta
	$i = count($this->_aItems);
	return $i;
	
} // fin funcin cantItemsCesta

function leerCesta(){
         

	// Rutina de lectura de una cesta
	$sql = "SELECT * FROM Cesta
                 WHERE CestaID = '" . $this->CestaID."'";

	$rst=accederMySQL($sql);
	$this->_aLista = array();
	$this->_aLista = $rst->fetch_assoc();
	return $this->_aLista;
        
   	 
} // fin leerCesta

} // fin clase Cesta

?>

