<?php
class Cuenta { // clase Cuenta
//  explicacin captulo  18

  /*
   * Propiedades de la clase Cuenta 
   */   
	private $_aLista;
	private $_bDirty;
	
   /*
    * Mtodos de la clase Cuenta
    * Cuenta() // Constructor
    * aadirCuenta()
    * modificarCuenta()
    * eliminarCuenta()
    * leerCuenta() 
    * validarCuenta()
    */
   
function Cuenta($sLogin=""){ // constructor de la clase
     
	global $con; 
	$this->_bDirty = False;
	$this->_aLista = array();
	// Rutina de insercin de un nuevo Cuenta
	if ($sLogin <>"")  {
		$this->_aLista['LOGIN']= $sLogin;
		$this->LeerCuenta();
	}

} // fin constructor

function __get($nv){
		 
		// la funcin isset() verifica si la variable est asignada
		if (isset($this->_aLista[$nv]) ) {
			return $this->_aLista[$nv];
		}
		else{
			return False;
		} 
}  // fin funcin _get
	 
function __set($nv,$val){
		 
		$this->_aLista[$nv] = $val;
		$this->_bDirty = True;
		return True;
		
} // fin funcin _set

function leerCuenta(){ // lee una cuenta

	global $con; 
	// Rutina de lectura de un  Cuenta
         
	$sql = "SELECT * FROM CUENTAS
            WHERE LOGIN = \"" . $this->LOGIN."\";" ;

	$rst = AccederMySQL($sql);
	$this->_aLista = $rst->fetch_assoc();
	return $this->_aLista;
   	 
} // fin leerCuenta


function aadirCuenta() { // Aadir un nuevo Cuenta
	global $con;
	// Rutina de insercin de una nueva Cuenta
	
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sqln="";
	$sqlv="";
	
	foreach ($this->_aLista as $key => $value){  
                  $sqln =  $sqln .  $key. " ,";
                  $sqlv = $sqlv . "'".$value."',";
               }
	
	$sql = "INSERT INTO CUENTAS ( ".substr($sqln,0,strlen($sqln)-1).
                ") VALUES (".substr($sqlv,0,strlen($sqlv)-1).");";
 
	$rst = AccederMySQL($sql);
   
} // fin aadir Cuenta

function eliminarCuenta() { // elimina una cuenta
	global $con;
   
	$sql= "DELETE FROM CUENTAS
            WHERE   LOGIN = \"".$this->LOGIN."\";";

	$rst = AccederMySQL($sql);
         

} // fin funcin EliminarCuenta


function modificarCuenta() { // Modifica los datos de un Cuenta

	global $con;
	// Rutina de insercin de un nuevo Cuenta

	if ($this->_bDirty) {
		$this->UltimaMod = date("Y-m-d H:i:s");
		$sql= "UPDATE CUENTAS SET ";
	
		foreach ($this->_aLista as $key => $value){  
               if ($key <> "LOGIN"){    
                  $sql =  $sql . " " . $key . " = '". $value . "' ,";
               }
		}
		$sql = substr($sql,0,strlen($sql)-1)." WHERE LOGIN = '".$this->LOGIN ."';";
	}
	$this->_bDirty = False;
       
	$rst = AccederMySQL($sql);

} // fin ModificarCuenta   
         
  
function validarCuenta($sPasswd){ // valida una cuenta
         
    if ($this->PalabraPaso == $sPasswd){
        	return True;
	} 
	else {
        	return False;
	}
  	 
} // fin validarCuenta
 
} // fin clase
 
?>

