<?php
class Proveedor { // clase Proveedor
    // explicacin en captulo 16
    
	private $_aLista=array();
	private $_bDirty=False;
	
   /*
    * Mtodos
    * Proveedor() // Constructor
    * aadirProveedor()
    * modificarProveedor()
    * leerProveedor() 
    */
   
function Proveedor($iProveedorID=0){
     
	// obtiene los datos de un proveedor
	$this->ProveedorID = $iProveedorID;
	if ($iProveedorID <>0)  { // ya existe el Proveedor
            $this->leerProveedor($iProveedorID);
	}  
        
 
} // fin constructor

function __get($nv){
		 
	// la funcin isset() verifica si la variable est asignada
	if (isset($this->_aLista[$nv]) ) 
 		return $this->_aLista[$nv];
	else
		return False;

}  // fin funcin _get
	 
function __set($nv,$val){

	// asigna un valor a un elemento de la matriz
	$this->_aLista[$nv] = $val;
	$this->_bDirty = True;
	return True;
		
} // fin funcin _set
	
function aadirProveedor() { // Aadir un nuevo Proveedor
 
	// Rutina de insercin de un nuevo Proveedor
	$this->UltimaMod = date("Y-m-d H:i:s");
	$this->FechaCreacion = date("Y-m-d H:i:s");
	$sqln="";
	$sqlv="";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "ProveedorID"){    
                  $sqln =  $sqln .  $key. " ,";
                  $sqlv = $sqlv . "\"".$value."\",";
        }
	}
	$sql = "INSERT INTO Proveedores ( ".substr($sqln,0,strlen($sqln)-1).
                ") VALUES (".substr($sqlv,0,strlen($sqlv)-1).");";
 
 	// obtiene el valor de autoincremento
	$this->ProveedorID = accederMySQL($sql,"ID");
	$this->_Dirty = False;
  
   
} // fin aadirProveedor()
    
function modificarProveedor() { // Modifica los datos de un Proveedor
       
	// Rutina de modificacin de Proveedor
	// no hay modificaciones pendientes
	if (!$this->_bDirty) return;
	
	
	$this->UltimaMod = date("Y-m-d H:i:s");
	$sql= "UPDATE Proveedores SET ";
	foreach ($this->_aLista as $key => $value){  
		if ($key <> "ProveedorID"){    
			$sql =  $sql . " " . $key . " = \"". $value . "\" ,";
		}
	}
	$sql = substr($sql,0,strlen($sql)-1)." WHERE ProveedorID = ".$this->ProveedorID .";";
	
	$rst = accederMySQL($sql);
	$this->_bDirty = False;
         
         
} // fin ModificarProveedor   
         
function eliminarProveedor() {
      
	// se verifica que ese proveedor no sea proveedor vigente 
    $sql="SELECT Count(*) FROM Libros 
            WHERE 
            ProveedorID = \"".$this->ProveedorID."\";";

	// crea el conjunto de resultados
	$rst=accederMySQL($sql);

      
	$row = $rst->fetch_row();
	if ($row[0] <> 0) {
		// No se elimina el proveedor: es proveedor vigente.
		tratarError(LIT16008);
		return;
	}
      
	$sql="DELETE FROM Proveedores 
			WHERE ProveedorID = \"".$this->ProveedorID."\";";
      
 	$rst = accederMySQL($sql);
 	$rst->free();

}

private function leerProveedor($iProveedorID){
         
	// Rutina de lectura de un  Proveedor
	$sql = "SELECT * FROM Proveedores
                 WHERE ProveedorID = " . $iProveedorID ;

	$rst = accederMySQL($sql);

	$this->_aLista = $rst->fetch_assoc();
	$rst->free();
        
   	 
} // fin leerProveedor
    
 
    
   
} // fin clase
 
?>

