<?php
// archivo: articulos.php
// explicacin captulo 28

// Este archivo: /Foros/articulos.php

////////////////////////////////////////////////////
// archivos de inclusin
////////////////////////////////////////////////////
require_once("plantilla.php");

// Esta pgina permite introducir artculos en los temas 
// del foro
// Tambin se incluye un buscador para limitar la lista de articulos
// visualizados
 
 
// informacin del encabezado
asignarEncabezado();


//$_SESSION['Cliente']= 6;
//$_POST["iTemaID"] =1;
//$_POST["iRefArticuloID"] =1;
//$_POST["iTitulo"] = "42 ";
//$_POST["iTexto"] = "42";
//$_POST["Op"] ="Aadir";
//$_POST["BTitulo"] ="oooooo";
//$_POST["BTema"] ="Base ";
//$_POST["BUsuario"] ="kkkk ";
//$_POST["BFecha"] ="2005-06-26";
//$_GET["pag"] =1;
//$_GET["filtro"] =" WHERE A.TemaID <> 99";
 
 
// logotipo y men de navegacin
abrirPagina(true,$aMENUGEN);

 
////////////////////////////////////////////////////
// Se establece la conexin 
// con un usuario predeterminado 
// con privilegios limitados
////////////////////////////////////////////////////
conectar(USERNORMAL,PSWUSERNORMAL);

// //////////////////////////////////////////////////
// Para responder o aadir hay que autenticarse
// //////////////////////////////////////////////////
if (($_POST["Op"] == "Aadir" )||($_POST["Op"] == "Responder" )){
	// si no ha iniciado una sesin se deber autenticarse
	// o registrarse
      	if (!isset($_SESSION['Cliente'])) 
             redirect (SITE_URL."/compra/autenticarse.php?Ret=".SELF); 

}
// obtine los datos del cliente (sesin vigente) 
$oCli = New Cliente;

////////////////////////////////////////////////////
// Rutinas de operaciones de actualizacin de una fila
////////////////////////////////////////////////////
$oArt = new Articulo();

// Rutina de insercin de un nuevo articulo  
if (($_POST["Op"]=="Aadir")) {
	$oArt->TemaID = $_POST["iTemaID"];
	$oArt->RefArticuloID = 0;
	if (isset($_POST["iRefArticuloID"]))  $oArt->RefArticuloID = $_POST["iRefArticuloID"];
	$oArt->Titulo = $_POST["iTitulo"];
	$oArt->Texto = $_POST["iTexto"];
	$oArt->Revisado = "0";
	$oArt->Usuario = $oCli->EMail;
	$oArt->aadirArticulo();
	//  artculos aadido
	$texto= LIT15018;
	
	// se mantiene en el tema vigente
	$sFiltro=" WHERE A.TemaID = ".$_POST['iTemaID'] ;  
               
}


////////////////////////////////////////////////////
// Rutina de filtrado de articulos
////////////////////////////////////////////////////

elseif ($_POST["Op"]=="Buscar") {
	$aFiltro = array();
	if (trim($_POST['BTitulo']) <>"") 	$aFiltro[]	=" A.Titulo Like '%".trim($_POST['BTitulo'])."%' ";
	if (trim($_POST['BTexto']) <>"")	$aFiltro[]	=" A.Texto Like '%".trim($_POST['BTexto'])."%' ";
	if (trim($_POST['BUsuario']) <>"") 	$aFiltro[]	=" A.Usuario Like '%".trim($_POST['BUsuario'])."%' ";
	if (trim($_POST['BTema']) <>"") 	$aFiltro[]	=" T.Nombre Like '%".trim($_POST['BTema'])."%' ";
	if (trim($_POST['BFecha']) <>"") 	$aFiltro[]	=" A.FechaCreacion >= DATE('".trim($_POST['BFecha'])."') ";

	// esta pgina nunca mostrar artculos sin revisar
	$sFiltro = " WHERE A.Revisado = 1 ";
 
	$i = 0 ;
	while ($i < count($aFiltro)) {
		$sFiltro .= " AND " . $aFiltro[$i] ;
		$i++;
	}
  
 	//  artculos seleccionados
	$texto= LIT15016;
}


////////////////////////////////////////////////////
// Rutina de filtrado de articulos desde una referencia
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="Ver rbol") {
	redirect("arbol.php?Secuencia=".trim($_POST['vSecuencia']));
}  


////////////////////////////////////////////////////
// Rutina de filtrado de articulos por 
// artculo y su referencia
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="Ver referencia") {
	
	$sFiltro=" WHERE ArticuloID = ".trim($_POST['vRefArticuloID']).  
                " OR ArticuloID = ".trim($_POST['vArticuloID'])." ";
  
	$texto= LIT15017 .trim($_POST['vRefArticuloID']);
}

////////////////////////////////////////////////////
// Rutina de respuesta
// artculo y su referencia
////////////////////////////////////////////////////
elseif ($_POST["Op"]=="Responder") {	 
      
	$iTemaID = $_POST["vTemaID"];
	$iRefArticuloID = $_POST["vArticuloID"];
	$iTitulo = "Resp: ".$_POST["vTitulo"];
	$sFiltro=" WHERE  A.ArticuloID = ".trim($_POST['vArticuloID'])." ";

}
   

////////////////////////////////////////////////////
// Rutina de filtrado de articulos  desde rbol.php
////////////////////////////////////////////////////
elseif (isset($_GET["NumArt"])) {
	$sFiltro=" WHERE  A.ArticuloID = ".trim($_GET['NumArt'])." ";
  
}

$iPag = 1;
if (isset($_GET["pag"])) {
	$sFiltro = stripslashes(urldecode($_GET["filtro"]));
	$iPag = $_GET["pag"];
}

////////////////////////////////////////////////////
// Obtener los articulos  
////////////////////////////////////////////////////
$oArts= New Articulos();
$aArts = $oArts->leerArticulos($sFiltro);
 

////////////////////////////////////////////////////
// Obtener la lista de temas vigentes
////////////////////////////////////////////////////
$oTemas = New Temas();
$aTemas = $oTemas->leerTemas("");

if (isset($texto) ) echo $texto."<BR>";

echo LIT15002 . $oArts->cantArticulos() .")<BR>";

echo "<a href='#aadir'>".LIT15003."</a>";

// //////////////////////////////////////////////////
// Mostrar todos los articulos seleccionados
// //////////////////////////////////////////////////
// Genera la tabla para bsquedas en el catlogo
tabBuscarForo($oArts->cantArticulos()); 

// Pagina la respuesta
// no muestra toda la respuesta en una 
// nica pgina 
$i = ($iPag * ROWARTS)- ROWARTS; 
$tope = $i + ROWARTS;
if ($tope > $oArts->cantArticulos()) $tope = $oArts->cantArticulos();

for  ($i; $i < $tope;$i++)    {
  
	echo "<form name='form15".$i."' method='POST' action='".SELF."' enctype='multipart/form-data'>";
	echo "<table valign='top' width='640' border='1'>";
	echo "<input type='hidden' name='vArticuloID' value=\"".clean($aArts[$i]['ArticuloID'])."\">";
	echo "<input type='hidden' name='vSecuencia' value=\"".clean($aArts[$i]['Secuencia'])."\">";
	echo "<input type='hidden' name='vTemaID' value=\"".clean($aArts[$i]['TemaID'])."\">";
	echo "<tr><td>".LIT15008."<b>".$aArts[$i]['NombreT']."</b></td>";
	echo "<td>".LIT15011."<b>".clean($aArts[$i]['FechaCreacion'])."</b></td>";
	echo "<td>".LIT15005."<b>".clean($aArts[$i]['Usuario'])."</b></td></tr>";
	echo "<input type='hidden' name='vRefArticuloID' value=\"".clean($aArts[$i]['RefArticuloID'])."\">";
	echo "<tr><td valign='top' colspan='3'>".LIT15010.clean($aArts[$i]['Titulo'])."</td></tr>";
	echo "<tr><td valign='top' colspan='3'>".LIT15004.clean($aArts[$i]['Texto'])."</td></tr>";
	echo "</table>";
  
  
	// Botones submit
	if ($aArts[$i]['RefArticuloID']<>"0"){
		echo "<input type='image' src ='".PATHGIF."arbol.gif'  width=25 height=25  
			value='rbol' TITLE='".LIT00014."'   onClick='document.form15".$i.".Op.value=\"Ver rbol\";' >\n"; 
		echo "<input type='image' src ='".PATHGIF."referencia.gif'  width=25 height=25  
			value='Ref' TITLE='".LIT00016."'   onClick='document.form15".$i.".Op.value=\"Ver referencia\";' >\n";
	}  
	echo "<input type='image' src ='".PATHGIF."responder.gif'  width=25 height=25
		value='Responder' TITLE='".LIT00015."' onClick='document.form15".$i.".Op.value=\"Responder\";' >\n";
	echo "<input type='hidden' name='Op' value=' '>\n";
	 
	echo "</form>";

}

paginarRespuesta($iPag,$oArts->cantArticulos(),ROWARTS,$sFiltro);



////////////////////////////////////////////////////
// Formulario de insercin de nuevos articulos
////////////////////////////////////////////////////
echo "<a name='aadir'></a>";
echo "<form name='form16' method='POST' action='".SELF."' enctype='multipart/form-data'>";
echo "<table valign='top' width='640' border='1'>";
if ($_POST["Op"]<>"Responder") {
	// insercin de artculos que no responden a 
	// otro anterior
	// Select de temas
	echo "<tr><td>".LIT15008."<select name='iTemaID'>";
	reset($aTemas);
	foreach ($aTemas as $temp) 
        echo "<option value='".$temp['TemaID']."'" .$sel.">".$temp['Nombre']."</option>";
		echo "</select></td></tr>";
}
else {
	// en las respuestas a un artculo no se modifica ni el tema
	// ni la referencia al artculo
	echo "<input type='hidden' name='iRefArticuloID' value=\"".$iRefArticuloID."\">";
	echo "<input type='hidden' name='iTemaID' value=\"".$iTemaID."\">";
}
 
echo "<tr><td>".LIT15010."<textarea  cols='70' rows='2' name='iTitulo'>".$iTitulo."</textarea></td></tr>";
echo "<tr><td>".LIT15004."<textarea  cols='70' rows='10' name='iTexto'></textarea></td></tr>";
echo "</table>";
echo "<input type='image' src ='".PATHGIF."insertar.gif'  
	value='Aadir' TITLE='".LIT00009."' width=25 height=25 onClick='document.form16.Op.value=\"Aadir\";' >\n";
echo "<input type='hidden' name='Op' value=' '>\n";
echo "</form>";

// informacin de pie de pgina
cerrarPagina();
?>

 