<?php
class Cuentas { // clase Cuentas
	// explicacin captulo 13

	/**
     * Propiedad 
     */
	private $_aLista=array();
	/*
    * Mtodos
    * Cuentas() // Constructor
    * leerCuentas($sFiltro, $sSort="Nombre ASC", $iPage=0)
    * cantCuentas()
    */

function Cuentas() {

	$this->_aLista = array();

}

/**
* Obtiene la lista de cuentas
*
*/
function LeerCuentas($sFiltro, $sSort="Login ASC", $iPage=0) {


	$sFiltro ? $WHERE = $sFiltro  : $WHERE = "";

	// Generacin de la cadena de consulta SQL
	$sql = "SELECT *  FROM Cuentas "
		. $WHERE .
		"   ORDER BY  "  .$sSort .
		" LIMIT   ".$iPage.", ".ROWCOUNT;

	$rst = accederMySQL($sql);

	$i = 0;

	// Bucle por el conjunto de resultados
	while ($aFila = $rst->fetch_assoc()) {

		$this->_aLista[$i]['LOGIN'] = gmq($aFila['LOGIN']);
		$this->_aLista[$i]['PalabraPaso'] = gmq($aFila['PalabraPaso']);
		$i++;
	}

	// liberar el conjunto de resultados
	$rst->free();

	// Devuelve la matriz
	return $this->_aLista;
	
} // fin funcin leerCuentas()

function cantCuentas() {

	return count($this->_aLista);

} // fin funcin cantCuentas()

} // fin Clase Cuentas

?>
