<?php
class Proveedores {
	// explicacin en captulo 16
	/**
     * Propiedad 
     */
	private $_aLista=array();
	
	/*
    * Mtodos
    * Proveedores() // Constructor
    * leerProveedores($sFiltro, $sSort="Nombre ASC", $iPage=0)
    * cantProveedores()
    */

function Proveedores() {

 	// en el constructor no hacemos nada

}
	
function leerProveedores($sFiltro="", $sSort="Nombre ASC", $iPage=0) {


	$sFiltro ?  $WHERE = $sFiltro: $WHERE = "" ;

	// Generacin de la cadena de consulta SQL
	$sql = "SELECT *  FROM Proveedores "
		      . $WHERE .
		      " ORDER BY  "  .$sSort .
		      " LIMIT   "      .$iPage.", ".ROWCOUNT;
		
	$rst = accederMySQL($sql); 

	$i = 0;

	// Bucle por el conjunto de resultados
	while ($aFila = $rst->fetch_assoc()) {
		$this->_aLista[$i] = $aFila;
		$i++;
	}

	// liberar el conjunto de resultados
	$rst->free();

	// Devuelve la matriz
	return $this->_aLista;
 
} // fun funcin leerProveedores()

function cantProveedores() {
	return count($this->_aLista);
} // fun funcin cantProveedores()

} // fin clase Proveedores


?>
